package net.mysoftworks.modulecompiler.model.meta;


import net.mysoftworks.modulecompiler.model.values.RawValue;
import net.mysoftworks.modulecompiler.model.visitor.MetaFieldVisitor;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.text.StringEscapeUtils;
import org.apache.commons.text.translate.CharSequenceTranslator;
import org.apache.commons.text.translate.NumericEntityEscaper;
import org.w3c.dom.Document;

import javax.persistence.*;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathFactory;
import java.io.ByteArrayInputStream;
import java.io.StringReader;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Date;
import java.sql.Time;
import java.sql.Timestamp;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Map;
import java.util.regex.Pattern;

/**
 * MetaGruppo generated by hbm2java
 */
@Entity
@DiscriminatorValue("TEXT")
public class MetaTextField extends MetaField implements java.io.Serializable {

	@Override
	public void accept(MetaFieldVisitor visitor) {
		visitor.visit(this);
	}

	public enum TEXT_TYPE {
		INPUT,TEXTAREA
	}
	private static final long serialVersionUID = 1L;

	public static Map<String,Constructor> allJavaTypes = new HashMap<>();
	static {
		try {
			allJavaTypes.put(Calendar.class.getName(), Date.class.getConstructor(long.class));
			allJavaTypes.put(Boolean.class.getName(), Boolean.class.getConstructor(String.class));
			allJavaTypes.put(Float.class.getName(), Float.class.getConstructor(String.class));
			allJavaTypes.put(Double.class.getName(), Double.class.getConstructor(String.class));
			allJavaTypes.put(Integer.class.getName(), Integer.class.getConstructor(String.class));
			allJavaTypes.put(BigDecimal.class.getName(), BigDecimal.class.getConstructor(String.class));
			allJavaTypes.put(Long.class.getName(), Long.class.getConstructor(String.class));
			allJavaTypes.put(Short.class.getName(), Short.class.getConstructor(String.class));
			allJavaTypes.put(Byte.class.getName(), Byte.class.getConstructor(String.class));
			allJavaTypes.put(Character.class.getName(), Character.class.getConstructor(char.class));
			allJavaTypes.put(String.class.getName(), String.class.getConstructor(String.class));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static RawValue instantiate(String javaType, String sValue) {
		Class cl = null;
		RawValue out=null;
		Object formattedValue = null;

			try {
				cl = Class.forName(javaType);
			} catch (Exception e) {
				e.printStackTrace();
				throw new RuntimeException(e);
			}
		if (sValue!=null) {
			Constructor constr = allJavaTypes.get(javaType);
			if (cl.equals(Boolean.class) ||
					cl.equals(Float.class) ||
					cl.equals(Double.class) ||
					cl.equals(Integer.class) ||
					cl.equals(BigDecimal.class) ||
					cl.equals(Long.class) ||
					cl.equals(Short.class) ||
					cl.equals(Byte.class) ||
					cl.equals(String.class)) {
				try {
					if (cl.equals(Float.class) ||
							cl.equals(Double.class) ||
							cl.equals(BigDecimal.class)) {
//						Pattern.compile("([\\+\\-])?(\\d+)\\.(\\d+)(,\\d+)");
						sValue = sValue.replaceAll("\\.","").replaceAll(",",".");
					}
					formattedValue = constr.newInstance(sValue);
				} catch (InstantiationException e) {
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					e.printStackTrace();
				} catch (InvocationTargetException e) {
					e.printStackTrace();
				}
			}

			if (cl.equals(Date.class) ||
					cl.equals(Timestamp.class) ||
					cl.equals(Time.class)) {
				long time = Long.parseLong(sValue);
				try {
					formattedValue = constr.newInstance(time);
				} catch (InstantiationException e) {
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					e.printStackTrace();
				} catch (InvocationTargetException e) {
					e.printStackTrace();
				}
			}
			if (cl.equals(Character.class)) {
				try {
					formattedValue = constr.newInstance(sValue.charAt(0));
				} catch (InstantiationException e) {
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					e.printStackTrace();
				} catch (InvocationTargetException e) {
					e.printStackTrace();
				}
			}
		}
		if (formattedValue==null && StringUtils.isNotBlank(sValue)) {
			throw new RuntimeException("Wrong class:" + cl + " for value " + sValue);
		} else {
			out = new RawValue();
			if (cl.equals(Boolean.class)) {
				out.setBooleanValue((Boolean) formattedValue);
			} else if (cl.equals(Float.class)) {
				out.setFloatValue((Float) formattedValue);
			} else if (cl.equals(Double.class)) {
				out.setDoubleValue((Double) formattedValue);

			} else if (cl.equals(Integer.class)) {
				out.setIntValue((Integer) formattedValue);

			} else if (cl.equals(BigDecimal.class)) {
				out.setBigDValue((BigDecimal) formattedValue);

			} else if (cl.equals(Long.class)) {
				out.setLongValue((Long) formattedValue);

			} else if (cl.equals(Short.class)) {
				out.setShortValue((Short) formattedValue);

			} else if (cl.equals(Byte.class)) {
				out.setByteValue((Byte) formattedValue);

			} else if (cl.equals(String.class)) {
				out.setStringValue((String) formattedValue);

			} else if (cl.equals(Calendar.class)) {
				out.setDateValue((Calendar) formattedValue);

			} else if (cl.equals(Character.class)) {
				out.setStringValue(new StringBuilder().append((Character) formattedValue).toString());
			}

		}
		return out;

	}


	public RawValue instantiate(String sValue) {
		return instantiate(javaType,sValue);
	}



	public MetaTextField(){super(BUSINESS_FIELD_TYPE.TEXT);	}
	public MetaTextField(MetaTextField source) {
		super(source);
		this.regex = source.regex;
		this.textType = source.textType;
		this.javaType = source.javaType;
	}

	@Column(name="JAVA_TYPE")
	private String javaType=String.class.getName();

	@Column(name="REGEX")
	private String regex;

	@Transient
	private Pattern pattern;

	@Column(name="SUB_TYPE")
	@Enumerated(EnumType.STRING)
	private TEXT_TYPE textType=TEXT_TYPE.INPUT;

	public TEXT_TYPE getTextType() {
		return textType;
	}

	public void setTextType(TEXT_TYPE textType) {
		this.textType = textType;
	}

	public String getRegex() {
		return regex;
	}

	public void setRegex(String regex) {
		this.regex = regex;
		updatePattern();
	}

	public String getJavaType() {
		return javaType;
	}

	public void setJavaType(String javaType) {
		this.javaType = javaType;
	}
	@PostLoad
	private void updatePattern()  {
		if (regex!=null)pattern = Pattern.compile(regex);
	}

	public Pattern getPattern() {
		return pattern;
	}

	public Object viewValue(RawValue rawValue) {
		return doGetValue(rawValue,false);
	}

	private Object doGetValue(RawValue rawValue,boolean create) {
		if (Date.class.getName().equals(javaType)) {
			return rawValue.getDateValue();
		}
		if (Timestamp.class.getName().equals(javaType)) {
			return rawValue.getDateValue();
		}
		if (Time.class.getName().equals(javaType)) {
			return rawValue.getDateValue();
		}
		if (Boolean.class.getName().equals(javaType)) {
			return rawValue.getBooleanValue();
		}
		if (Float.class.getName().equals(javaType)) {
			return rawValue.getFloatValue();
		}
		if (Double.class.getName().equals(javaType)) {
			return rawValue.getDoubleValue();
		}
		if (Integer.class.getName().equals(javaType)) {
			return rawValue.getIntValue();
		}
		if (BigDecimal.class.getName().equals(javaType)) {
			return rawValue.getBigDValue();
		}
		if (Long.class.getName().equals(javaType)) {
			return rawValue.getLongValue();
		}
		if (Short.class.getName().equals(javaType)) {
			return rawValue.getShortValue();
		}
		if (BigInteger.class.getName().equals(javaType)) {
			return rawValue.getLongValue();
		}
		if (Byte.class.getName().equals(javaType)) {
			return rawValue.getByteValue();
		}
		if (Character.class.getName().equals(javaType)) {
			String sv = rawValue.getStringValue();
			if (sv!=null && sv.length()!=0) return sv.charAt(0);
			return null;
		}
		if (String.class.getName().equals(javaType)) {
			return NumericEntityEscaper.between(0x003C, 0x003E).translate(rawValue.getStringValue());
		}
		throw  new RuntimeException("Undefined value for javaType:" + javaType);
	}

    public boolean isInteger() {
        if (Integer.class.getName().equals(javaType) || Long.class.getName().equals(javaType) || Short.class.getName().equals(javaType) ||
                BigInteger.class.getName().equals(javaType) || Byte.class.getName().equals(javaType)) {
            return true;
        }
        return false;
    }

    public boolean isDecimal() {
        if (Float.class.getName().equals(javaType) || Double.class.getName().equals(javaType) || BigDecimal.class.getName().equals(javaType)) {
            return true;
        }
        return false;
    }


    public boolean isNumeric() {
		if (Float.class.getName().equals(javaType) || Double.class.getName().equals(javaType) || Integer.class.getName().equals(javaType) ||
				BigDecimal.class.getName().equals(javaType) || Long.class.getName().equals(javaType) || Short.class.getName().equals(javaType) ||
				BigInteger.class.getName().equals(javaType) || Byte.class.getName().equals(javaType)) {
			return true;
		}
		return false;
	}
	@Override
	public String toString() {
		final StringBuilder sb = new StringBuilder("MetaTextField{");
		sb.append("regex='").append(regex).append('\'');
		sb.append(", pattern=").append(pattern);
		sb.append(", textType=").append(textType);
		sb.append('}').append(super.toString());
		return sb.toString();
	}

}
